/*
 * indicator-network - user interface for connman
 * Copyright 2010 Canonical Ltd.
 *
 * Authors:
 * Kalle Valo <kalle.valo@canonical.com>
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 3, as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranties of
 * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __DBUS_SHARED_NAMES_H__
#define __DBUS_SHARED_NAMES_H__ 1

#define INDICATOR_NETWORK_DBUS_NAME  "com.canonical.indicator.network"
#define INDICATOR_NETWORK_DBUS_OBJECT "/com/canonical/indicator/network/menu"
#define INDICATOR_NETWORK_SERVICE_DBUS_OBJECT "/"
#define INDICATOR_NETWORK_SERVICE_DBUS_INTERFACE "com.canonical.indicator.network.BackendManager"
#define INDICATOR_NETWORK_DBUS_VERSION  0

#define INDICATOR_NETWORK_BACKEND_NAME  "com.canonical.indicator.network.backend"
#define INDICATOR_NETWORK_BACKEND_MANAGER_PATH "/com/canonical/indicator/network/backend/manager"
#define INDICATOR_NETWORK_BACKEND_INTERFACE "com.canonical.indicator.network.backend"
#define INDICATOR_NETWORK_BACKEND_MANAGER_INTERFACE \
  INDICATOR_NETWORK_BACKEND_INTERFACE ".Manager"

#define INDICATOR_NETWORK_AGENT_NAME  "com.canonical.indicator.network.agent"
#define INDICATOR_NETWORK_AGENT_OBJECT "/com/canonical/indicator/network/agent"
#define INDICATOR_NETWORK_AGENT_INTERFACE "com.canonical.indicator.network.agent"

#define INDICATOR_NETWORK_SIGNAL_ICON_CHANGED "IconChanged"
#define INDICATOR_NETWORK_SIGNAL_ACCESSIBLE_DESC_CHANGED "AccessibleDescChanged"

#define SERVICE_MENUITEM_NAME			"service-item"
#define SERVICE_MENUITEM_PROP_PROTECTION_MODE	"protection"

#define SERVICE_MENUITEM_PROP_OPEN		0
#define SERVICE_MENUITEM_PROP_PROTECTED		1

#define TECH_MENUITEM_NAME			"tech-item"

#endif /* __DBUS_SHARED_NAMES_H__ */
