/* infobox.c generated by valac 0.11.6, the Vala compiler
 * generated from infobox.vala, do not modify */

/*
 * indicator-network - user interface for connman
 * Copyright 2010-2011 Canonical Ltd.
 *
 * Authors:
 * Andrew Higginson
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 3, as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranties of
 * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <float.h>
#include <math.h>


#define TYPE_INFO_BOX (info_box_get_type ())
#define INFO_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INFO_BOX, InfoBox))
#define INFO_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INFO_BOX, InfoBoxClass))
#define IS_INFO_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INFO_BOX))
#define IS_INFO_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_INFO_BOX))
#define INFO_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INFO_BOX, InfoBoxClass))

typedef struct _InfoBox InfoBox;
typedef struct _InfoBoxClass InfoBoxClass;
typedef struct _InfoBoxPrivate InfoBoxPrivate;
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

struct _InfoBox {
	GtkHBox parent_instance;
	InfoBoxPrivate * priv;
};

struct _InfoBoxClass {
	GtkHBoxClass parent_class;
};


static gpointer info_box_parent_class = NULL;

GType info_box_get_type (void) G_GNUC_CONST;
enum  {
	INFO_BOX_DUMMY_PROPERTY
};
#define INFO_BOX_YPAD 1
#define INFO_BOX_XPAD 1
InfoBox* info_box_new (gboolean homogeneous, gint spacing);
InfoBox* info_box_construct (GType object_type, gboolean homogeneous, gint spacing);
gboolean info_box_on_expose_event (InfoBox* self, GdkEventExpose* event);
static gboolean _info_box_on_expose_event_gtk_widget_expose_event (GtkWidget* _sender, GdkEventExpose* event, gpointer self);


static gboolean _info_box_on_expose_event_gtk_widget_expose_event (GtkWidget* _sender, GdkEventExpose* event, gpointer self) {
	gboolean result;
	result = info_box_on_expose_event (self, event);
	return result;
}


InfoBox* info_box_construct (GType object_type, gboolean homogeneous, gint spacing) {
	InfoBox * self = NULL;
	self = (InfoBox*) g_object_new (object_type, NULL);
	gtk_box_set_homogeneous ((GtkBox*) self, homogeneous);
	gtk_box_set_spacing ((GtkBox*) self, spacing);
	g_signal_connect_object ((GtkWidget*) self, "expose-event", (GCallback) _info_box_on_expose_event_gtk_widget_expose_event, self, 0);
	return self;
}


InfoBox* info_box_new (gboolean homogeneous, gint spacing) {
	return info_box_construct (TYPE_INFO_BOX, homogeneous, spacing);
}


gboolean info_box_on_expose_event (InfoBox* self, GdkEventExpose* event) {
	gboolean result = FALSE;
	cairo_t* _tmp0_ = NULL;
	cairo_t* cr;
	gint x;
	gint y;
	gint width;
	gint height;
	GtkStyle* _tmp1_ = NULL;
	GdkColor fill;
	GtkStyle* _tmp2_ = NULL;
	GdkColor stroke;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gdk_cairo_create ((GdkDrawable*) ((GtkWidget*) self)->window);
	cr = _tmp0_;
	x = (gint) (((GtkWidget*) self)->allocation.x + INFO_BOX_XPAD);
	y = (gint) (((GtkWidget*) self)->allocation.y + INFO_BOX_YPAD);
	width = (gint) (((GtkWidget*) self)->allocation.width - (INFO_BOX_XPAD * 2));
	height = (gint) (((GtkWidget*) self)->allocation.height - (INFO_BOX_YPAD * 2));
	_tmp1_ = gtk_widget_get_style ((GtkWidget*) self);
	fill = _tmp1_->mid[((GtkWidget*) self)->state];
	_tmp2_ = gtk_widget_get_style ((GtkWidget*) self);
	stroke = _tmp2_->dark[((GtkWidget*) self)->state];
	cairo_rectangle (cr, (gdouble) x, (gdouble) y, (gdouble) width, (gdouble) height);
	cairo_set_source_rgb (cr, ((gdouble) stroke.red) / 65535.0, ((gdouble) stroke.green) / 65535.0, ((gdouble) stroke.blue) / 65535.0);
	cairo_stroke_preserve (cr);
	cairo_set_source_rgb (cr, ((gdouble) fill.red) / 65535.0, ((gdouble) fill.green) / 65535.0, ((gdouble) fill.blue) / 65535.0);
	cairo_fill (cr);
	result = FALSE;
	_cairo_destroy0 (cr);
	return result;
}


static void info_box_class_init (InfoBoxClass * klass) {
	info_box_parent_class = g_type_class_peek_parent (klass);
}


static void info_box_instance_init (InfoBox * self) {
}


GType info_box_get_type (void) {
	static volatile gsize info_box_type_id__volatile = 0;
	if (g_once_init_enter (&info_box_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (InfoBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) info_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (InfoBox), 0, (GInstanceInitFunc) info_box_instance_init, NULL };
		GType info_box_type_id;
		info_box_type_id = g_type_register_static (GTK_TYPE_HBOX, "InfoBox", &g_define_type_info, 0);
		g_once_init_leave (&info_box_type_id__volatile, info_box_type_id);
	}
	return info_box_type_id__volatile;
}



